<?php
/*
Plugin Name: Počasí widget
Description: Generuje shortcode dle nastaveného města, který po umístění na web zobrazuje widget s předpovědí počasí pocasicz.cz. 
Version: 0.2.1
Author: David Kvetovský
*/
class PocasiczPlugin{

      	function __construct() {
            add_shortcode('pocasicz', array($this, 'myOutput'));
            add_action('admin_menu', array($this, 'myMenu'));
      	}

        private function myDebug($echo){        
            if (isset($_GET['debug'])) {
                echo "<pre>";
                var_dump($echo);
                echo "<pre>";           
            }     
        }
        
        public function myOutput($atts) {
                    
            $args=shortcode_atts(array(
              'mesto' => 'Praha',
              'typ' => 0
            ), $atts);        
            if ($atts["typ"]==1) {
                $dimensions="width='110' height='251'";
                $title="Počasí na 14 dní";
				$title2="Předpověď počasí na 14 dní";
            }    
            else {
                $dimensions="width='230' height='102'";
                $title="Počasí na 14 dní";
				$title2="Předpověď počasí na 14 dní";
            }
            return "<style>#widget-pocasicz iframe{margin-bottom: 0px;}</style><div id='widget-pocasicz' style='text-align:center;'> <iframe border='0' frameborder='0' scrolling='no' ".$dimensions." src='https://www.pocasicz.cz/ikonky?mesto=".$args["mesto"]."&amp;umisteni=".$args["typ"]."'></iframe><br /><a style='font-size:11px;' href='https://www.pocasicz.cz/predpoved-na-14-dnu/'>".$title2."</a><br><a style='font-size:11px;' href='https://www.pocasicz.cz/'>".$title."</a></div>";
        }

        public function myMenu() {
          	add_menu_page( 'Počasí widget', 'Počasí', 'manage_options', 'pocasicz', array($this, 'myOption'), 'dashicons-palmtree' );                 
        }

        private function myReadFile() {
            $lines = file(plugin_dir_path( __FILE__ )."/cities-list.txt");

            foreach ($lines as $line_num => $line) {
                $cities[trim(strstr($line, ' '))]=strstr($line, ' ', true);
            }
            
            return $cities; 
        }

        public function myOption() {

            global $wpdb;

            if (!empty($_POST["pocasi_cities"])) {
                $wpdb->replace($wpdb->prefix.'options', array( 'option_name' => 'pocasi_cities', 'option_value' => $_POST["pocasi_cities"] ));            
                $wpdb->replace($wpdb->prefix.'options', array( 'option_name' => 'pocasi_dimension', 'option_value' => $_POST["pocasi_dimension"] ));            
            }
            
            $saved["city"] = $wpdb->get_row( "SELECT * FROM ".$wpdb->prefix."options WHERE option_name = 'pocasi_cities' " );                        
            $saved["dimension"] = $wpdb->get_row( "SELECT * FROM ".$wpdb->prefix."options WHERE option_name = 'pocasi_dimension' " );                        
            
            $def_cities=$this->myReadFile();
                        
            echo "
              <div class='wrap'>
                  <h1>Počasí nastavení</h1>
                  <form method='post' action='' novalidate='novalidate'>
                      <table class='form-table'><tbody>
                          <tr>
                              <th scope='row'><label for='pocasi_cities'>Město</label></th>
                              <td><select name='pocasi_cities' id='pocasi_cities'>";

                                echo "<option value=''>-- vyber --</option>";                              
                                foreach ($def_cities as $def_key=>$def_value){
                                    echo "<option value='".$def_value."' ".($def_value==$saved["city"]->option_value?"selected='selected'":"").">".$def_key."</option>";
                                }
                              
                              	echo "   
                              </select></td>
                          </tr>
                          <tr>
                              <th scope='row'><label for='pocasi_dimension'>Typ</label></th>
                              <td><select name='pocasi_dimension' id='pocasi_dimension'>
                                <option value='0' ".($saved["dimension"]->option_value==0?"selected='selected'":"").">Horizontální</option>
                                <option value='1' ".($saved["dimension"]->option_value==1?"selected='selected'":"").">Vertikální</option>";                              
                              	echo "   
                              </select></td>
                          </tr>
                          <tr>
                              <th scope='row'><label for='pocasi_shortcode'>Shortcode</label></th>
                              <td>";
                                if (!empty($saved["city"]->option_value))
                                    $sc="[pocasicz mesto=\"".$saved["city"]->option_value."\" typ=\"".$saved["dimension"]->option_value."\"]";
                                else
                                    $sc="Pro vygenerování shortcode nastavte Město.";                            
                                echo "<input type='text' style='font-family: Courier; width: 400px; font-weight: bold' readonly name='pocasi_shortcode' id='pocasi_shortcode' value='".$sc."' />                        
                              </td>    
                          </tr>
                          
                          <tr>
                              <th scope='row'><label for='pocasi_preview'>Náhled</label></th>
                              <td style='width: 230px; display: block;'>";
                                 echo do_shortcode("[pocasicz mesto=\"".$saved["city"]->option_value."\" typ=\"".$saved["dimension"]->option_value."\"]");
                              echo "</td>    
                          </tr>                          

                      </tbody></table>
                  <p class='submit'>
                      <input name='submit' id='submit' class='button button-primary' value='Vygenerovat' type='submit'>
                  </p>                      
              </div>";
 
        }
}

new PocasiczPlugin();
?>